#!/usr/bin/python
'''
get a new ami given a running instance 
'''

import datetime
import logging

import bellatrix
from bellatrix.lib.ec2_lib import Ec2lib
from bellatrix.lib import bellatrix_util
from bellatrix.lib import util


class Run():
    def __init__(self, key, sec, app_name): 
        self._ec2 = Ec2lib(key, sec) 
        self._app_name = app_name
        self.out_file = bellatrix_util.getOutFile(__file__)
        

    def burnInstance(self, instance, config_name):
        config_name = config_name + "-" + datetime.datetime.now().isoformat()
        new_ami = self._ec2.createImage(instance, config_name, "generated by " 
                                        + self._app_name)
        logging.info("ami: %s is being generated for configuration: %s" 
                     % (new_ami, config_name))
        util.writeFile(self.out_file, new_ami + "," + config_name)

def run(instance, config_name):
    r = Run(bellatrix_util.getKey(), bellatrix_util.getSecret(), bellatrix.APP)
    r.burnInstance(instance, config_name)
    return 0

if __name__ == '__main__':
    sys.exit(run(*sys.argv[1:])) 

